'use client';

import { useCallback, useEffect, useMemo, useState } from 'react';
import { useRouter } from 'next/navigation';
import { useFormik } from 'formik';
import { toast } from 'react-hot-toast';

import { Icon } from '@iconify/react';
import Button from '@/components/Button';
import TextInput from '@/components/input/TextInput';
import { useModal } from '@/components/Modal';
import ConfirmationModal from '@/components/modal/ConfirmationModal';
import RequirePermission from '@/components/helper/RequirePermission';

import {
  UomFormSchema,
  UomFormValues,
  UpdateUomFormSchema,
} from '@/components/pages/master-data/uom/form/UomForm.schema';
import { isResponseError } from '@/lib/api-helper';
import {
  CreateUomPayload,
  Uom,
  UpdateUomPayload,
} from '@/types/api/master-data/uom';
import { UomApi } from '@/services/api/master-data';
import { cn } from '@/lib/helper';
import { useFormikErrorList } from '@/services/hooks/useFormikErrorList';
import AlertErrorList from '@/components/helper/form/FormErrors';

interface UomFormProps {
  type?: 'add' | 'edit' | 'detail';
  initialValues?: Uom;
}

const UomForm = ({ type = 'add', initialValues }: UomFormProps) => {
  const router = useRouter();
  const deleteModal = useModal();

  const [uomFormErrorMessage, setUomFormErrorMessage] = useState('');
  const [isDeleteLoading, setIsDeleteLoading] = useState(false);

  const createUomHandler = useCallback(
    async (payload: CreateUomPayload) => {
      const createUomRes = await UomApi.create(payload);

      if (isResponseError(createUomRes)) {
        setUomFormErrorMessage(createUomRes.message);
        return;
      }

      toast.success(createUomRes?.message as string);
      router.push('/master-data/uom');
    },
    [router]
  );

  const updateUomHandler = useCallback(
    async (uomId: number, payload: UpdateUomPayload) => {
      const updateUomRes = await UomApi.update(uomId, payload);

      if (updateUomRes?.status === 'error') {
        setUomFormErrorMessage(updateUomRes.message);
        return;
      }

      toast.success(updateUomRes?.message as string);
      router.refresh();
      router.push('/master-data/uom');
    },
    [router]
  );

  const formikInitialValues = useMemo<UomFormValues>(() => {
    return {
      name: initialValues?.name ?? '',
    };
  }, [initialValues]);

  const formik = useFormik<UomFormValues>({
    initialValues: formikInitialValues,
    validationSchema: type === 'edit' ? UpdateUomFormSchema : UomFormSchema,
    onSubmit: async (values) => {
      setUomFormErrorMessage('');

      const uomPayload: CreateUomPayload = {
        name: values.name,
      };

      switch (type) {
        case 'add':
          await createUomHandler(uomPayload);
          break;

        case 'edit':
          await updateUomHandler(initialValues?.id as number, uomPayload);
          break;
      }
    },
  });

  const { setValues: formikSetValues } = formik;

  const deleteUomClickHandler = () => {
    deleteModal.openModal();
  };

  const confirmationModalDeleteClickHandler = async () => {
    setIsDeleteLoading(true);

    await UomApi.delete(initialValues?.id as number);

    deleteModal.closeModal();
    toast.success('Successfully delete UOM!');
    setIsDeleteLoading(false);
    router.push('/master-data/uom');
  };

  useEffect(() => {
    formikSetValues(formikInitialValues);
  }, [formikSetValues, formikInitialValues]);

  // ===== Formik Error List =====
  const { formErrorList, close, handleFormSubmit } = useFormikErrorList(formik);

  return (
    <>
      <section className='w-full max-w-xl'>
        <header className='flex flex-col gap-4'>
          <Button
            href='/master-data/uom'
            variant='link'
            className='w-fit p-0 text-primary'
          >
            <Icon icon='uil:arrow-left' width={24} height={24} />
            Kembali
          </Button>

          <h1 className='text-2xl font-bold text-center'>
            {type === 'add' && 'Tambah UOM'}
            {type === 'edit' && 'Edit UOM'}
            {type === 'detail' && 'Detail UOM'}
          </h1>
        </header>

        <form
          onSubmit={handleFormSubmit}
          onReset={formik.handleReset}
          className='w-full mt-8 flex flex-col gap-6'
        >
          <div className='flex flex-col gap-4'>
            <TextInput
              required
              label='Nama'
              name='name'
              placeholder='Masukkan nama UOM'
              value={formik.values.name}
              onChange={formik.handleChange}
              onBlur={formik.handleBlur}
              isError={formik.touched.name && Boolean(formik.errors.name)}
              errorMessage={formik.errors.name}
              readOnly={type === 'detail'}
            />
          </div>

          <div className='flex flex-row justify-between gap-2 flex-wrap'>
            {type !== 'add' && (
              <div className='flex flex-row justify-start gap-2'>
                <RequirePermission permissions='lti.master.uoms.delete'>
                  <Button
                    type='button'
                    color='error'
                    onClick={deleteUomClickHandler}
                    className='px-4'
                  >
                    <Icon
                      icon='material-symbols:delete-outline-rounded'
                      width={24}
                      height={24}
                      className='justify-start text-sm'
                    />
                    Delete
                  </Button>
                </RequirePermission>

                {type !== 'edit' && (
                  <RequirePermission permissions='lti.master.uoms.update'>
                    <Button
                      type='button'
                      color='warning'
                      href={`/master-data/uom/detail/edit/?uomId=${initialValues?.id}`}
                      className='px-4'
                    >
                      <Icon
                        icon='material-symbols:edit-outline'
                        width={24}
                        height={24}
                        className='justify-start text-sm'
                      />
                      Edit
                    </Button>
                  </RequirePermission>
                )}
              </div>
            )}

            <AlertErrorList formErrorList={formErrorList} onClose={close} />

            {type !== 'detail' && (
              <div
                className={cn('flex flex-row justify-end gap-2', {
                  'w-full': type === 'add',
                })}
              >
                <Button type='reset' color='warning' className='px-4'>
                  Reset
                </Button>

                <Button
                  type='submit'
                  color='primary'
                  isLoading={formik.isSubmitting}
                  disabled={formik.isSubmitting}
                  className='px-4'
                >
                  Submit
                </Button>
              </div>
            )}
          </div>

          {uomFormErrorMessage && (
            <div role='alert' className='alert alert-error'>
              <Icon
                icon='material-symbols:error-outline'
                width={24}
                height={24}
              />
              <span>{uomFormErrorMessage}</span>
            </div>
          )}
        </form>
      </section>

      {type !== 'add' && (
        <ConfirmationModal
          ref={deleteModal.ref}
          type='error'
          text={`Apakah anda yakin ingin menghapus data UOM ini (${initialValues?.name})?`}
          secondaryButton={{
            text: 'Tidak',
          }}
          primaryButton={{
            text: 'Ya',
            color: 'error',
            isLoading: isDeleteLoading,
            onClick: confirmationModalDeleteClickHandler,
          }}
        />
      )}
    </>
  );
};

export default UomForm;
